# by USS Sovereign - Happy Holidays

# Imports
import App
import Foundation
import MissionLib
import Custom.SelfManh.SelfManhiem
from Custom.SelfManh.Libs import NoTransport

mode = Foundation.MutatorDef("Self Manh")

# Classes
class LoadTrigger(Foundation.TriggerDef):
        def __init__(self, name, eventKey, dict = {}):
                Foundation.TriggerDef.__init__(self, name, eventKey, dict)

        def __call__(self, pObject, pEvent, dict = {}):
                Custom.SelfManh.SelfManhiem.init()
                    
LoadTrigger('Self-Manhiem', Foundation.TriggerDef.ET_FND_CREATE_PLAYER_SHIP, dict = { 'modes': [ mode ] } )

class SetExitReset(Foundation.TriggerDef):
        def __init__(self, name, eventKey, dict = {}):
                Foundation.TriggerDef.__init__(self, name, eventKey, dict)

        def __call__(self, pObject, pEvent, dict = {}):
                # Call the function only if the player is the one triggering it
                pShip = App.ShipClass_Cast(pEvent.GetDestination())
		if pShip is None:
		    return 0
		
		pPlayer = MissionLib.GetPlayer()
		if pPlayer is None:
                    return 0
                
		if pShip.GetName() == pPlayer.GetName(): 
                    Custom.SelfManh.SelfManhiem.SelfManhRapidEnd()
                else:
                    return 0
                    
SetExitReset('Self-Manhiem', App.ET_EXITED_SET, dict = { 'modes': [ mode ] } )

class BanTransport(Foundation.TriggerDef):
        def __init__(self, name, eventKey, dict = {}):
                Foundation.TriggerDef.__init__(self, name, eventKey, dict)

        def __call__(self, pObject, pEvent, dict = {}):
                NoTransport.IdentityCheck(pObject, pEvent)
                    
BanTransport('Self-Manhiem', App.ET_SET_PLAYER, dict = { 'modes': [ mode ] } )
