# by USS Sovereign, Happy Holidays everybody
# This was written 2 years ago initially, seems as a good present for the community

# Imports
import App
import MissionLib
import loadspacehelper
import string
from Custom.SelfManh.Libs import DS9FXMenuLib

# Globals
pButton = None
AbortTimer = None
AbortTime = None
PowerLoss = None
SelfManhName = "Self-Manhiem Ship"

# Initial Capability check
def init():
        global pButton, AbortTime, PowerLoss
        
        DeleteMenuButton("XO", "Self-Manhiem")

        pPlayer = MissionLib.GetPlayer()

        fPlugin = GetShipType(pPlayer) 

        try:
            fModule = __import__("Custom.SelfManh.Plugins." + fPlugin)

            if hasattr(fModule, "Data"):
                
                fData = fModule.Data()

                if fData.has_key('ShipPyFile') and fData.has_key('ManhiemDuration') and fData.has_key('PowerLoss'):

                    if fPlugin == fData['ShipPyFile']:

                        pButton = DS9FXMenuLib.CreateButton("Self-Manhiem", "XO", __name__ + ".SelfManhiemSequence")

                        NormalColor = App.TGColorA() 
                        NormalColor.SetRGBA(0.8, 0.6, 0.8, 1.0)
                        HilightedColor = App.TGColorA() 
                        HilightedColor.SetRGBA(0.92, 0.76, 0.92, 1.0)
                        NormalColor2 = App.TGColorA() 
                        NormalColor2.SetRGBA(0.5, 0.5, 1.0, 1.0)
                        HilightedColor2 = App.TGColorA() 
                        HilightedColor2.SetRGBA(0.61, 0.61, 1.0, 1.0)
                        DisabledColor = App.TGColorA() 
                        DisabledColor.SetRGBA(0.25, 0.25, 0.25, 1.0)
                        pButton.SetUseUIHeight(0)
                        pButton.SetNormalColor(NormalColor)
                        pButton.SetHighlightedColor(HilightedColor)
                        pButton.SetSelectedColor(NormalColor)
                        pButton.SetDisabledColor(DisabledColor)
                        pButton.SetColorBasedOnFlags()

                        AbortTime = fData['ManhiemDuration']
                        PowerLoss = fData['PowerLoss']

        except:
            return 0

# Sequence part
def SelfManhiemSequence(pObject, pEvent):
         pPlayer = MissionLib.GetPlayer()
         # Can use it?
         pPower = pPlayer.GetPowerSubsystem()
	 pMainBatteryPower = pPower.GetMainBatteryPower()
	 pMainBatteryLimit = pPower.GetMainBatteryLimit()
	 if (pMainBatteryPower <= (pMainBatteryLimit*.05)):
            return
         pSequence = App.TGSequence_Create ()
         pSequence.AddAction(App.TGScriptAction_Create("MissionLib", "StartCutscene"), None, 0)
         pSequence.AddAction(App.TGScriptAction_Create("Actions.CameraScriptActions", "StartCinematicMode", 0), None, 0)
         pSequence.AddAction(App.TGScriptAction_Create("Actions.CameraScriptActions", "CutsceneCameraBegin", pPlayer.GetContainingSet().GetName ()), None, 0)
         pSequence.AddAction(App.TGScriptAction_Create("Actions.CameraScriptActions", "DropAndWatch", pPlayer.GetContainingSet().GetName(), pPlayer.GetName ()), None, 0)
         pSequence.AddAction(App.TGScriptAction_Create(__name__, "DrainShipPower"), None, 0)
         pSequence.AddAction(App.TGScriptAction_Create(__name__, "SetAI"), None, 0)
         pSequence.AddAction(App.TGScriptAction_Create(__name__, "PlaySound"), None, 1.0)
         pSequence.AddAction(App.TGScriptAction_Create(__name__, "InitiateGFX"), None, 1.0)
         pSequence.AddAction(App.TGScriptAction_Create(__name__, "SelfManhiemEffect"), None, 6.0)
         pSequence.AddAction(App.TGScriptAction_Create(__name__, "ClearAI"), None, 10.0)
         pSequence.AddAction(App.TGScriptAction_Create("Actions.CameraScriptActions", "CutsceneCameraEnd", pPlayer.GetContainingSet().GetName ()), None, 10.5)
         if App.g_kSetManager.GetSet("bridge"):
                 pAction = App.TGScriptAction_Create("Actions.CameraScriptActions", "ChangeRenderedSet", "bridge")
                 pSequence.AddAction(pAction, None, 10.5)
         pSequence.AddAction(App.TGScriptAction_Create("MissionLib", "EndCutscene"), None, 10.5)
         pSequence.Play()


def DrainShipPower(pAction):
         global PowerLoss
         pPlayer = MissionLib.GetPlayer()
         pPower = pPlayer.GetPowerSubsystem()
	 pMainBatteryPower = pPower.GetMainBatteryPower()
	 pLoss = PowerLoss
	 pPower.SetMainBatteryPower(pMainBatteryPower - pLoss)
         return 0
  
def PlaySound(pAction):
         # Play the sound
         pSound = App.TGSound_Create("sfx/Custom/SuperWeaponsPack/Self-Manhiem/Manheim.mp3", "SMFXAlert", 0)
         pSound.SetSFX(0) 
         pSound.SetInterface(1)
         pSound.SetPriority(1)
         pSound.SetVolume(1)
         App.g_kSoundManager.PlaySound("SMFXAlert")

         return 0

def SetAI(pAction):
        pPlayer = MissionLib.GetPlayer()
        import Custom.SelfManh.Libs.DS9FXWormholeExitingSeqAI
        pPlayerCast = App.ShipClass_Cast(pPlayer)
        pPlayerCast.SetAI(Custom.SelfManh.Libs.DS9FXWormholeExitingSeqAI.CreateAI(pPlayerCast))
        return 0


def ClearAI(pAction):        
        pPlayer = MissionLib.GetPlayer()        
        import Custom.SelfManh.Libs.DS9FXStayAI
        pPlayerCast = App.ShipClass_Cast(pPlayer)
        pPlayerCast.SetAI(Custom.SelfManh.Libs.DS9FXStayAI.CreateAI(pPlayerCast))

        # Clear AI's
        pPlayer.ClearAI()

        import AI.Player.Stay
	MissionLib.SetPlayerAI("Helm", AI.Player.Stay.CreateAI(pPlayer))

        return 0

def InitiateGFX(pAction):
        from Custom.SelfManh.Libs import ManhGFX
        
        ManhGFX.StartGFX()
        for i in range(20):
                ManhGFX.CreateGFX()

        return 0

def SelfManhiemEffect(pAction):
        global pButton, AbortTimer, AbortTime

        if hasattr(pButton, 'SetDisabled'):
            if pButton.IsEnabled():
                pButton.SetDisabled()

        pPlayer	= MissionLib.GetPlayer()
	pSet = pPlayer.GetContainingSet()
	fType = GetShipType(pPlayer) 

	loadspacehelper.CreateShip(fType, pSet, SelfManhName, "", 0, 1)

	pMission = App.Game_GetCurrentGame().GetCurrentEpisode().GetCurrentMission()
        pMission.GetFriendlyGroup().AddName(SelfManhName)

        pSelfManh = MissionLib.GetShip(SelfManhName, pSet)
        pSelfManh.EnableCollisionsWith(pPlayer, 0)

        pPosition = pPlayer.GetWorldLocation()
        pForward = pPlayer.GetWorldForwardTG()
        pUp = pPlayer.GetWorldUpTG()

        pSelfManh.AlignToVectors(pForward, pUp)
        pSelfManh.SetTranslate(pPosition)
        pSelfManh.UpdateNodeOnly()

        NoQBR = None
        import QuickBattle.QuickBattle
        try:
            import Custom.QuickBattleGame.QuickBattle
        except:
            NoQBR = 'NoQBR'

        if NoQBR == "NoQBR":
            if QuickBattle.QuickBattle.pFriendlies:
                    import QuickBattle.QuickBattleFriendlyAI
                    pSelfManh.SetAI(QuickBattle.QuickBattleFriendlyAI.CreateAI(pSelfManh))
                    
        else:
            if QuickBattle.QuickBattle.pFriendlies:
                    import QuickBattle.QuickBattleFriendlyAI
                    pSelfManh.SetAI(QuickBattle.QuickBattleFriendlyAI.CreateAI(pSelfManh))

            elif Custom.QuickBattleGame.QuickBattle.pFriendlies:
                    import Custom.QuickBattleGame.QuickBattleFriendlyAI
                    pSelfManh.SetAI(Custom.QuickBattleGame.QuickBattleFriendlyAI.CreateAI(pSelfManh, 1, 1))
 
        AbortTimer = MissionLib.CreateTimer(DS9FXMenuLib.GetNextEventType(), __name__ + ".SelfManhEnd", App.g_kUtopiaModule.GetGameTime() + AbortTime, 0, 0)

        return 0

def SelfManhEnd(pObject, pEvent):
        SelfManhRapidEnd()

def SelfManhRapidEnd():
        global pButton

        try:
            pMission = App.Game_GetCurrentGame().GetCurrentEpisode().GetCurrentMission()
            pMission.GetFriendlyGroup().RemoveName(SelfManhName)
        except:
            pass
        try:
            MissionLib.GetPlayer().GetContainingSet().DeleteObjectFromSet(SelfManhName)
        except:
            pass

        if hasattr(pButton, 'SetEnabled'):
            if not pButton.IsEnabled():
                pButton.SetEnabled()

def GetShipType(pShip):
        if pShip.GetScript():
                return string.split(pShip.GetScript(), '.')[-1]
        return None
            
def DeleteMenuButton(sMenuName, sButtonName, sSubMenuName = None):
        pMenu   = GetBridgeMenu(sMenuName)
        pButton = pMenu.GetButton(sButtonName)
        if sSubMenuName != None:
                pMenu = pMenu.GetSubmenu(sSubMenuName)
                pButton = pSubMenu.GetButton(sButtonName)

        pMenu.DeleteChild(pButton)


def GetBridgeMenu(menuName):
        pTactCtrlWindow = App.TacticalControlWindow_GetTacticalControlWindow()
        pDatabase = App.g_kLocalizationManager.Load("data/TGL/Bridge Menus.tgl")
        if(pDatabase is None):
                return
        App.g_kLocalizationManager.Unload(pDatabase)
        return pTactCtrlWindow.FindMenu(pDatabase.GetString(menuName))

def CreateAI(pShip):
	pPlayer = MissionLib.GetPlayer()

        Random = lambda fMin, fMax : App.g_kSystemWrapper.GetRandomNumber((fMax - fMin) * 1000.0) / 1000.0 - fMin
        # Range values used in the AI.
        fInRange = 150.0 + Random(-25, 20)

	#########################################
	# Creating PlainAI Intercept at (279, 253)
	pIntercept = App.PlainAI_Create(pShip, "Intercept")
	pIntercept.SetScriptModule("Intercept")
	pIntercept.SetInterruptable(1)
	pScript = pIntercept.GetScriptInstance()
	pScript.SetTargetObjectName(pPlayer.GetName())
	# Done creating PlainAI Intercept
	#########################################
	#########################################
	# Creating ConditionalAI ConditionIntercept at (148, 273)
	## Conditions:
	#### Condition HaveToIntercept
	pHaveToIntercept = App.ConditionScript_Create("Conditions.ConditionInRange", "ConditionInRange", fInRange, pPlayer.GetName(), pShip.GetName())
	## Evaluation function:
	def EvalFunc(bHaveToIntercept):
		ACTIVE = App.ArtificialIntelligence.US_ACTIVE
		DORMANT = App.ArtificialIntelligence.US_DORMANT
		DONE = App.ArtificialIntelligence.US_DONE
		if not bHaveToIntercept:
			return ACTIVE
		return DORMANT
	## The ConditionalAI:
	pConditionIntercept = App.ConditionalAI_Create(pShip, "ConditionIntercept")
	pConditionIntercept.SetInterruptable(1)
	pConditionIntercept.SetContainedAI(pIntercept)
	pConditionIntercept.AddCondition(pHaveToIntercept)
	pConditionIntercept.SetEvaluationFunction(EvalFunc)
	# Done creating ConditionalAI ConditionIntercept
	#########################################
	#########################################
	# Creating PlainAI Follow at (280, 181)
	pFollow = App.PlainAI_Create(pShip, "Follow")
	pFollow.SetScriptModule("FollowObject")
	pFollow.SetInterruptable(1)
	pScript = pFollow.GetScriptInstance()
	pScript.SetFollowObjectName(pPlayer.GetName())
	pScript.SetRoughDistances(10,20,30)
	# Done creating PlainAI Follow
	#########################################
	#########################################
	# Creating ConditionalAI PlayerInSameSet at (164, 201)
	## Conditions:
	#### Condition InSet
	pInSet = App.ConditionScript_Create("Conditions.ConditionAllInSameSet", "ConditionAllInSameSet", pShip.GetName(), pPlayer.GetName())
	## Evaluation function:
	def EvalFunc(bInSet):
		ACTIVE = App.ArtificialIntelligence.US_ACTIVE
		DORMANT = App.ArtificialIntelligence.US_DORMANT
		DONE = App.ArtificialIntelligence.US_DONE
		if bInSet:
			# Player is in the same set as we are.
			return ACTIVE
		return DORMANT
	## The ConditionalAI:
	pPlayerInSameSet = App.ConditionalAI_Create(pShip, "PlayerInSameSet")
	pPlayerInSameSet.SetInterruptable(1)
	pPlayerInSameSet.SetContainedAI(pFollow)
	pPlayerInSameSet.AddCondition(pInSet)
	pPlayerInSameSet.SetEvaluationFunction(EvalFunc)
	# Done creating ConditionalAI PlayerInSameSet
	#########################################
	#########################################
	# Creating CompoundAI FollowWarp at (281, 125)
	import AI.Compound.FollowThroughWarp
	pFollowWarp = AI.Compound.FollowThroughWarp.CreateAI(pShip, pPlayer.GetName())
	# Done creating CompoundAI FollowWarp
	#########################################
	#########################################
	# Creating PriorityListAI PriorityList at (47, 125)
	pPriorityList = App.PriorityListAI_Create(pShip, "PriorityList")
	pPriorityList.SetInterruptable(1)
	# SeqBlock is at (139, 132)
	pPriorityList.AddAI(pConditionIntercept, 1)
	pPriorityList.AddAI(pPlayerInSameSet, 2)
	pPriorityList.AddAI(pFollowWarp, 3)
	# Done creating PriorityListAI PriorityList
	#########################################
	#########################################
	# Creating PreprocessingAI AvoidObstacles at (6, 188)
	## Setup:
	import AI.Preprocessors
	pScript = AI.Preprocessors.AvoidObstacles()
	## The PreprocessingAI:
	pAvoidObstacles = App.PreprocessingAI_Create(pShip, "AvoidObstacles")
	pAvoidObstacles.SetInterruptable(1)
	pAvoidObstacles.SetPreprocessingMethod(pScript, "Update")
	pAvoidObstacles.SetContainedAI(pPriorityList)
	# Done creating PreprocessingAI AvoidObstacles
	#########################################
	return pAvoidObstacles
